import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.Random;

// skeleton of a Decoder
// reads samples from file, plus shows how to add noise
// you add code to decode the message

public class Decoder {

	// convenience function, linear -> dB
	public static double toDB(double in) {
		return 10.0 * Math.log10(in);
	}
	
	// convenience function, dB -> linear
	public static double fromDB(double in) {
		return Math.pow(10.0, in/10.0);
	}

	// the signal to be decoded
	double[] samples;
	
	public Decoder(double[] samples) {
		this.samples = samples;
	}

	public static void main(String[] args) {
		// hard-coded configuration, change as you like
		String fname = "samples-NRZ.txt";
		
		// a high SNR, should cause no errors
		double SNR = 10.0;
		
		// random number generator seed
		long seed = 0;
		double[] samples = null;
			
		// parse the file format to get noiseless samples
		try {

			BufferedReader in = new BufferedReader(new FileReader(fname));
			String line = null;
			int nsamp = Integer.parseInt(in.readLine());
			samples = new double[nsamp];
			int idx = 0;
			while ( (line = in.readLine() ) != null) {
				samples[idx++] = Double.parseDouble(line); 
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		System.out.println("Read " + samples.length + " samples from " + fname);
		
		// compute absolute noise level from known signal level and SNR
		double noiseVar = 1.0 / fromDB(SNR);
		Random noiseGen = new Random(seed);
		
		// create a copy of the samples and add Gaussian noise to each
		double[] nsamples = new double[samples.length];
		for (int i=0; i < samples.length; i++) {
			nsamples[i] = samples[i] + noiseVar * noiseGen.nextGaussian();
		}
		
		System.out.println("Added noise with variance of " + noiseVar + " for SNR of " + SNR + ", with random seed " + seed);

		// create a decoder, give it samples
		Decoder dec = new Decoder(nsamples);
	
		// you need to add the decoding somewhere!
	}	
}
